import 'dart:ui';

import 'package:coordinator_layout/coordinator_layout.dart';
import 'package:flutter/material.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
        visualDensity: VisualDensity.adaptivePlatformDensity,
      ),
      home: MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;

  void _incrementCounter() {
    setState(() {
      _counter++;
    });
  }

  @override
  Widget build(BuildContext context) {
    double headerMinHeight =
        kToolbarHeight + MediaQuery.of(context).padding.top;
    return Scaffold(
      body: CoordinatorLayout(
        headerMaxHeight: headerMinHeight + 80,
        headerMinHeight: headerMinHeight,
        headers: [
          Builder(builder: (context) {
            return SliverOverlapAbsorber(
              handle: NestedScrollView.sliverOverlapAbsorberHandleFor(context),
              sliver: SliverSafeArea(
                top: false,
                sliver: SliverCollapsingHeader(
                  builder: (context, offset, diff) {
                    return Card(
                      margin: EdgeInsets.only(bottom: 0),
                      child: SingleChildScrollView(
                        physics: NeverScrollableScrollPhysics(),
                        child: Stack(
                          children: <Widget>[
                            Opacity(
                              opacity: offset,
                              child: Container(
                                margin: EdgeInsets.only(
                                    top: headerMinHeight * (offset)),
                                padding: EdgeInsets.symmetric(
                                    horizontal: 32, vertical: 8),
                                child: Row(
                                  children: <Widget>[
                                    Expanded(
                                      flex: 1,
                                      child: Text("Point : 30,200"),
                                    ),
                                    FloatingActionButton.extended(
                                      backgroundColor: Colors.green,
                                      onPressed: () {},
                                      label: Text("View"),
                                    ),
                                  ],
                                ),
                              ),
                            ),
                            AppBar(
                              title: Text("Home"),
                            ),
                          ],
                        ),
                      ),
                    );
                  },
                ),
              ),
            );
          })
        ],
        body: ListView.builder(
            itemCount: 1,
            itemBuilder: (context, index) =>
                Container(height: null, child: buildBody(context))),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: _incrementCounter,
        tooltip: 'Increment',
        child: Icon(Icons.add),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }

  Center buildBody(BuildContext context) {
    return Center(
      child: Column(
        mainAxisAlignment: MainAxisAlignment.start,
        children: <Widget>[
          Text(
            'You have pushed the button this many times:',
          ),
          Text(
            '$_counter',
            style: Theme.of(context).textTheme.headline4,
          ),
        ],
      ),
    );
  }
}
